#ifndef KLX_BINARY_C_HPP
#define KLX_BINARY_C_HPP

#include "common.hpp"

//============================================================================
// <<compile-time binary constant>> library
//
//	_0b(1101) Ƚ񤤤 13 _0b(0111) Ƚ񤤤 7 
//	ɽ褦ư򤹤ޥ _0b ޤ
//
// [def]
//
//	_0b  : token -> uint
//
//		11bitޤǤɽǽg++, dmc Ǥ22bitޤOK
//
//	_0b2 : token -> token -> uint
//	_0b3 : token -> token -> token -> uint
//	_0b4 : token -> token -> token -> uint
//
//		8bitڤ2ʿɽԤΥޥ
//		_0b2(00001111,11110000) == 0x0ff0
//
// [ref]
//
//	http://www.flipcode.com/cgi-bin/msg.cgi?showThread=Tip-CPPCompileTimeBinConst&forum=totd&id=-1
//
//============================================================================

namespace klx { namespace detail {
	template<uint64 N> struct binary_c_impl {
		enum { value = N%8 + (binary_c_impl<N/8>::value << 1) };
	};
	template<> struct binary_c_impl<0> {
		enum { value=0 };
	};
}}

#define _0b(n)            (klx::uint(klx::detail::binary_c_impl<0##n>::value))
#define _0b2(n2,n1)       ((_0b(n2)<< 8) | _0b(n1))
#define _0b3(n3,n2,n1)    ((_0b(n3)<<16) | (_0b(n2)<<8) | _0b(n1))
#define _0b4(n4,n3,n2,n1) ((_0b(n4)<<24) | (_0b(n3)<<16) | (_0b(n2)<<8) | _0b(n1))



#endif // INCLUDE_GUARD
