#ifndef KLX_INITCONT_HPP
#define KLX_INITCONT_HPP

#include "common.hpp"

//============================================================================
// <<init container>> library
//
//	vector<int> x;
//	init_v(x) = 1,2,3,4,5,4,3,2,1;
//	ʤɤȤävector<int>ͤꤹ뤳ȤǤ褦ˤΡ
//
// [def]
//
//	init_v :
//		vector/list/deque ʤɡpush_back äƤΤǤꤹ롣
//
//	addto_v :
//		vector/list/deque ʤɡpush_back äƤΤǤɲä롣
//
//	init_q :
//		stack/queue/priority_queue ʤɡpush äƤΤǤꤹ롣
//
//	addto_q :
//		stack/queue/priority_queue ʤɡpush äƤΤǤɲä롣
//
//	init_s :
//		set/multiset ʤɡinsert äƤΤǤꤹ롣
//
//	addto_s :
//		set/multiset ʤɡinsert äƤΤǤɲä롣
//
// []
//
//	dmc Ǥϻѽޤ
//
// [ref]
//
//	http://www.bdsoft.com/tools/initutil.html
//
//============================================================================

namespace klx {

namespace detail
{
	//
	// operator, ˤäǤ򥳥ƥʤɲäƤΥ֥
	//
	#define CI_IMPL(name)                                              \
		template<class Cont>                                           \
		class ci_##name                                                \
		{                                                              \
		public:                                                        \
			ci_##name(Cont& c) : c(c) {}                               \
			ci_##name& operator, (const typename Cont::value_type& v)  \
			    { c.name(v); return *this; }                           \
		private:                                                       \
			Cont& c;                                                   \
		}
		// ci_push_back: vector,list,deque
		CI_IMPL(push_back);
		// ci_push: stack, queue
		CI_IMPL(push);
		// ci_insert: set
		CI_IMPL(insert);
	#undef CI_IMPL

	//
	// operator= ˤ볫ʬν
	//
	template<class Cont, template<class> class Impl>
	class ci_start_t
	{
	public:
		ci_start_t(Cont& c) : c(c) {}
		Impl<Cont> operator=(const typename Cont::value_type& v)
		  { return Impl<Cont>(c), v; }
	private:
		Cont& c;
	};
}

//
// ֥Ⱥؿfor push_back
//

template<class Cont>
inline
detail::ci_start_t<Cont,detail::ci_push_back> addto_v(Cont& c)
{
	return detail::ci_start_t<Cont,detail::ci_push_back>(c);
}
template<class Cont>
inline
detail::ci_start_t<Cont,detail::ci_push_back> init_v(Cont& c)
{
	c.clear();
	return addto_v(c);
}

//
// ֥Ⱥؿfor push
//

template<class Cont>
inline
detail::ci_start_t<Cont,detail::ci_insert> addto_s(Cont& c)
{
	return detail::ci_start_t<Cont,detail::ci_insert>(c);
}
template<class Cont>
inline
detail::ci_start_t<Cont,detail::ci_insert> init_s(Cont& c)
{
	c.clear();
	return addto_set(c);
}

//
// ֥Ⱥؿfor queue
//

template<class Cont>
inline
detail::ci_start_t<Cont,detail::ci_push> addto_q(Cont& c)
{
	return detail::ci_start_t<Cont,detail::ci_push>(c);
}
template<class Cont>
inline
detail::ci_start_t<Cont,detail::ci_push> init_q(Cont& c)
{
	c = Cont();
	return addto_q(c);
}






// ޤmapѤʤ
//-------------------------------
//template<typename K>
//struct key_holder
//{
//	key_holder(K k) : k(k) {}
//	K k;
//	template<typename T> pair<K,T> operator >> (T t){ return make_pair(k, t); }
//};
//template<typename K> key_holder<K> key(K k) { return key_holder<K>(k); }
//-------------------------------
// map<string,int> mp;
// init_s(mp) = key("hoge")>>10,  key("fuga")>>20,  key("hello")>>30;




}      // namespace end
#endif // INCLUDE_GUARD
